####################################################################################################
########## Script to get genes corresponding to a set of SNPSs ##############################
####################################################################################################

#### Required packages ####
library(data.table)
library(dplyr)
library(biomaRt)


#### Reading in the data frame containing SNPs along their corresponding chromosomal positions ####

df <- read.table("Selected_SNPs_RandomForest", header = T)

#### Getting the information on all the chicken genes available on Ensembl #####

ensembl = useMart("ensembl",dataset="ggallus_gene_ensembl")
attribute_list = c("ensembl_gene_id","chromosome_name","strand","start_position","end_position","gene_biotype","external_gene_name")
gene_info= getBM(attributes=attribute_list, mart = ensembl)

x <- data.table(gene_info)
setkey(x,chromosome_name,start_position,end_position)

y <- data.table(df)

##### A left and right boundy around every SNPs is required


y$Pos.left <- y$Position #### position of the SNPs on the chromosome
y$Pos.right <- y$Position

setkey(y,Chromosome, Pos.left, Pos.right)

geneslist <- list()
#### Considering one chromosome at a time 
for (i in 1:28) {
  x1 <- x[x$chromosome_name == i]
  y1 <- y[y$Chromosome == i]
  neargenes = foverlaps(x1,y1) %>% na.omit 
  neargeanslist[[i]] <- neargenes
}

Finalgenes <- do.call(rbind.data.frame, neargeanslist)

